- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Exponent::GUI::Controls::IControlRoot Interface Reference

Inheritance diagram for Exponent::GUI::Controls::IControlRoot:

List of all members.

## Detailed Description

Interface to a control root.

Date:
  19/03/2005

Author:
  Paul Chana

Version:
  1.0.0 Initial version

Note:
  All contents of this source code are copyright 2005 Exp Digital Uk.
  This source file is covered by the licence conditions of the Infinity API. You should have recieved a copy
  with the source code. If you didnt, please refer to http://www.expdigital.co.uk All content is the Intellectual property of Exp Digital Uk.
  Certain sections of this code may come from other sources. They are credited where applicable.
  If you have comments, suggestions or bug reports please visit http://support.expdigital.co.uk

Id
  IControlRoot.hpp,v 1.5 2007/02/11 02:16:22 paul Exp

Definition at line 64 of file IControlRoot.hpp.

## Public Types

- enum EControlRootSerialiseOption {
  e_serialiseToDisk = 0,
  e_serialiseFromDisk
  }
    Options for serialising to disk. More...

## Public Member Functions

- virtual void addControl (IControl *control)=0
- virtual void clearControls ()=0
- virtual bool controlIsLocked () const=0
- virtual void drawRootControl (CGraphics &graphics)=0
- virtual IControl * getControlAtIndex (const long index, bool isIndex)=0
- virtual IControl * getControlAtPoint (const CPoint &point)=0
- virtual long getControlIndex (IControl *control)=0
- virtual IControl * getDropEnabledControlAtPoint (const CPoint &point)=0
- virtual void getGlobalCoordinatesOfControl (IControl *control, CPoint &point)=0
- virtual IControl * getKeyEnabledControlAtPoint (const CPoint &point)=0
- virtual IControl * getLockedControl () const=0
- virtual IControl * getMouseEnabledControlAtPoint (const CPoint &point)=0
- virtual long getNumberOfControls ()=0
- virtual long getNumberOfInsertedControls ()=0
- virtual IWindow * getParentWindow () const=0
- virtual void getWindowCoordinatesOfControl (IControl *control, CPoint &point)=0
- virtual CPoint getWindowOffset ()=0
- IControlRoot ()
- virtual void lockControl (IControl *control)=0
- virtual void removeControl (IControl *control)=0
- virtual void setBackgroundImage (IImage *image)=0
- virtual void setParentWindow (IWindow *parent)=0
- virtual void startToolTipTimer ()=0
- virtual void stopToolTipTimer ()=0
- virtual void unlockControl ()=0
- virtual void updateArea (const CRect &area)=0
- virtual void updateControl (const long index, bool isIndex)=0
- virtual void updateControl (IControl *control)=0
- virtual ~IControlRoot ()

## Member Enumeration Documentation

enum Exponent::GUI::Controls::IControlRoot::EControlRootSerialiseOption

Options for serialising to disk.

Enumerator:

  e_serialiseToDisk | Serialise to disk
  e_serialiseFromDisk | Serialise from disk

Definition at line 74 of file IControlRoot.hpp.

## Constructor & Destructor Documentation

Exponent::GUI::Controls::IControlRoot::IControlRoot | ( |  | ) | `[inline]`

Construction

Definition at line 85 of file IControlRoot.hpp.

virtual Exponent::GUI::Controls::IControlRoot::~IControlRoot | ( |  | ) | `[inline, virtual]`

Destruction

Definition at line 90 of file IControlRoot.hpp.

## Member Function Documentation

virtual void Exponent::GUI::Controls::IControlRoot::addControl | ( | IControl * | control | ) | `[pure virtual]`

Add a control

Parameters:

  | control | The control to add

Implemented in Exponent::GUI::Controls::CControlPanel, and Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::clearControls | ( |  | ) | `[pure virtual]`

Remove all controls

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual bool Exponent::GUI::Controls::IControlRoot::controlIsLocked | ( |  | ) | const`[pure virtual]`

Is there a control locked

Return values:

  | bool | True if a control is locked, false otherwise

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::drawRootControl | ( | CGraphics & | graphics | ) | `[pure virtual]`

Draw the root control

Parameters:

  | graphics | The graphics context

virtual IControl* Exponent::GUI::Controls::IControlRoot::getControlAtIndex | ( | const long | index,
|  | bool | isIndex |
| ) |  |  | `[pure virtual]`

Get a specific index, or with a specific id, if isIndex = false

Parameters:

  | index | The index to get
  | isIndex | If true returns the control at index else returns the control with id of index

Return values:

  | IControl* | The control or null on error / not finiding it etc

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual IControl* Exponent::GUI::Controls::IControlRoot::getControlAtPoint | ( | const CPoint & | point | ) | `[pure virtual]`

Get the control at this point (point is relative to this' top left)

Parameters:

  | point | The position relative to this roots top left

Return values:

  | IControl* | The control, or null on error

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual long Exponent::GUI::Controls::IControlRoot::getControlIndex | ( | IControl * | control | ) | `[pure virtual]`

Get the index of a control

Parameters:

  | control | The control to find the index of

Return values:

  | long | The index of the control

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual IControl* Exponent::GUI::Controls::IControlRoot::getDropEnabledControlAtPoint | ( | const CPoint & | point | ) | `[pure virtual]`

Get he control at this point, checks for drop file enabling

Parameters:

  | point | The position relative to this roots top left

Return values:

  | IControl* | The control, or null on error

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::getGlobalCoordinatesOfControl | ( | IControl * | control,
|  | CPoint & | point |
| ) |  |  | `[pure virtual]`

Get the global location of the control in screen co-ordinates

Parameters:

  | control | The control to find the location of
  | point | The position of the control

Implemented in Exponent::GUI::Controls::CControlPanel, and Exponent::GUI::Controls::CControlRoot.

virtual IControl* Exponent::GUI::Controls::IControlRoot::getKeyEnabledControlAtPoint | ( | const CPoint & | point | ) | `[pure virtual]`

Get the key enabled control at this point, checks for key handling

Parameters:

  | point | The position relative to this roots top left

Return values:

  | IControl* | The control, or null on error

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual IControl* Exponent::GUI::Controls::IControlRoot::getLockedControl | ( |  | ) | const`[pure virtual]`

Get the locked control

Return values:

  | IControl* | The locked control

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual IControl* Exponent::GUI::Controls::IControlRoot::getMouseEnabledControlAtPoint | ( | const CPoint & | point | ) | `[pure virtual]`

Get the control at this point, checks for mouse enabling

Parameters:

  | point | The position relative to this roots top left

Return values:

  | IControl* | The control, or null on error

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual long Exponent::GUI::Controls::IControlRoot::getNumberOfControls | ( |  | ) | `[pure virtual]`

Get the number of controls embedded in this root

Return values:

  | long | The number of controls

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual long Exponent::GUI::Controls::IControlRoot::getNumberOfInsertedControls | ( |  | ) | `[pure virtual]`

Get the number of controls embedded in this root, actually inserted <= getNumberOfControls

Return values:

  | long | The array insert index

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual IWindow* Exponent::GUI::Controls::IControlRoot::getParentWindow | ( |  | ) | const`[pure virtual]`

Get the parent window

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::getWindowCoordinatesOfControl | ( | IControl * | control,
|  | CPoint & | point |
| ) |  |  | `[pure virtual]`

Get the window (absoloute) position of a control

Parameters:

  | control | The control to find the absolute position of
  | point | The position of the control on return

Implemented in Exponent::GUI::Controls::CControlPanel, Exponent::GUI::Controls::CControlRoot, and Exponent::GUI::Controls::CScrollPanel.

virtual CPoint Exponent::GUI::Controls::IControlRoot::getWindowOffset | ( |  | ) | `[pure virtual]`

Get window offset

Implemented in Exponent::GUI::Controls::CControlPanel, Exponent::GUI::Controls::CControlRoot, and Exponent::GUI::Controls::CScrollPanel.

virtual void Exponent::GUI::Controls::IControlRoot::lockControl | ( | IControl * | control | ) | `[pure virtual]`

Lock a control (only this control recieves mouse info)

Parameters:

  | control | The control to lock

Implemented in Exponent::GUI::Controls::CControlPanel, and Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::removeControl | ( | IControl * | control | ) | `[pure virtual]`

Remove a control

Parameters:

  | control | The control to remove

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::setBackgroundImage | ( | IImage * | image | ) | `[pure virtual]`

Set the background image

Parameters:

  | image | The background image for the control root

virtual void Exponent::GUI::Controls::IControlRoot::setParentWindow | ( | IWindow * | parent | ) | `[pure virtual]`

Set the parent window

virtual void Exponent::GUI::Controls::IControlRoot::startToolTipTimer | ( |  | ) | `[pure virtual]`

Start the timer to work out if the tool tip should fire up

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::stopToolTipTimer | ( |  | ) | `[pure virtual]`

Stop the tool tip timer from running

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::unlockControl | ( |  | ) | `[pure virtual]`

Unlock a control

Implemented in Exponent::GUI::Controls::CControlPanel, and Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::updateArea | ( | const CRect & | area | ) | `[pure virtual]`

Update an area

Parameters:

  | area | The area to update

Implemented in Exponent::GUI::Controls::CControlPanel, Exponent::GUI::Controls::CControlRoot, and Exponent::GUI::Controls::CScrollPanel.

virtual void Exponent::GUI::Controls::IControlRoot::updateControl | ( | const long | index,
|  | bool | isIndex |
| ) |  |  | `[pure virtual]`

Update (redraw) a control at a specific index, or with a specific id if isIndex = false

Parameters:

  | index | The index ot update
  | isIndex | If true index is the controls id, else its the direct array index

Implemented in Exponent::GUI::Controls::CControlRoot.

virtual void Exponent::GUI::Controls::IControlRoot::updateControl | ( | IControl * | control | ) | `[pure virtual]`

Update (redraw) a control

Parameters:

  | control | The control to redraw

Implemented in Exponent::GUI::Controls::CControlPanel, Exponent::GUI::Controls::CControlRoot, and Exponent::GUI::Controls::CScrollPanel.